<?php
/**
 
 * Clase para Firmar Documentos Electrónicos - SUNAT
 */
require_once 'lib/robrichards/xmlseclibs.php';

class FirmarXML
{

    public static function Firmar(DOMDocument $domDocument,$empresa)
    {
        $ReferenceNodeName = 'ExtensionContent';
        $privateKey        = file_get_contents('archivosPEM/private_key'.$empresa.'.pem');
        $publicKey         = file_get_contents('archivosPEM/public_key'.$empresa.'.pem');

        $objSign = new XMLSecurityDSig();
        $objSign->setCanonicalMethod(XMLSecurityDSig::EXC_C14N);
        $objSign->addReference(
            $domDocument,
            XMLSecurityDSig::SHA1,
            array('http://www.w3.org/2000/09/xmldsig#enveloped-signature'),
            $options = array('force_uri' => true)
        );

        $objKey = new XMLSecurityKey(XMLSecurityKey::RSA_SHA1, array('type' => 'private'));
        $objKey->loadKey($privateKey);

        // Firmar el archivo XML
        $objSign->sign($objKey, $domDocument->getElementsByTagName($ReferenceNodeName)->item(1));
        // Agregue la clave pública asociada a la firma
        $objSign->add509Cert($publicKey);

        // Retornamos nuestro XML firmafo
        return $domDocument;
    }

  public static function Firmarfactura(DOMDocument $domDocument,$empresa)
    {
        $ReferenceNodeName = 'ExtensionContent';
        $privateKey        = file_get_contents('archivosPEM/private_key'.$empresa.'.pem');
        $publicKey         = file_get_contents('archivosPEM/public_key'.$empresa.'.pem');

        $objSign = new XMLSecurityDSig();
        $objSign->setCanonicalMethod(XMLSecurityDSig::EXC_C14N);
        $objSign->addReference(
            $domDocument,
            XMLSecurityDSig::SHA1,
            array('http://www.w3.org/2000/09/xmldsig#enveloped-signature'),
            $options = array('force_uri' => true)
        );

        $objKey = new XMLSecurityKey(XMLSecurityKey::RSA_SHA1, array('type' => 'private'));
        $objKey->loadKey($privateKey);

        // Firmar el archivo XML
        $objSign->sign($objKey, $domDocument->getElementsByTagName($ReferenceNodeName)->item(0));
        // Agregue la clave pública asociada a la firma
        $objSign->add509Cert($publicKey);

        // Retornamos nuestro XML firmafo
        return $domDocument;
    }

    public static function Firmar_baja(DOMDocument $domDocument,$empresa)
    {
        $ReferenceNodeName = 'ExtensionContent';
        $privateKey        = file_get_contents('archivosPEM/private_key'.$empresa.'.pem');
        $publicKey         = file_get_contents('archivosPEM/public_key'.$empresa.'.pem');

        $objSign = new XMLSecurityDSig();
        $objSign->setCanonicalMethod(XMLSecurityDSig::EXC_C14N);
        $objSign->addReference(
            $domDocument,
            XMLSecurityDSig::SHA1,
            array('http://www.w3.org/2000/09/xmldsig#enveloped-signature'),
            $options = array('force_uri' => true)
        );

        $objKey = new XMLSecurityKey(XMLSecurityKey::RSA_SHA1, array('type' => 'private'));
        $objKey->loadKey($privateKey);

        // Firmar el archivo XML
        $objSign->sign($objKey, $domDocument->getElementsByTagName($ReferenceNodeName)->item(0));
        // Agregue la clave pública asociada a la firma
        $objSign->add509Cert($publicKey);

        // Retornamos nuestro XML firmafo
        return $domDocument;
    }

   public static function Firmar_baja2(DOMDocument $domDocument,$empresa)
    {
        $ReferenceNodeName = 'ExtensionContent';
        $privateKey        = file_get_contents('archivosPEM/private_key'.$empresa.'.pem');
        $publicKey         = file_get_contents('archivosPEM/public_key'.$empresa.'.pem');

        $objSign = new XMLSecurityDSig();
        $objSign->setCanonicalMethod(XMLSecurityDSig::EXC_C14N);
        $objSign->addReference(
            $domDocument,
            XMLSecurityDSig::SHA1,
            array('http://www.w3.org/2000/09/xmldsig#enveloped-signature'),
            $options = array('force_uri' => true)
        );

        $objKey = new XMLSecurityKey(XMLSecurityKey::RSA_SHA1, array('type' => 'private'));
        $objKey->loadKey($privateKey);

        // Firmar el archivo XML
        $objSign->sign($objKey, $domDocument->getElementsByTagName($ReferenceNodeName)->item(0));
        // Agregue la clave pública asociada a la firma
        $objSign->add509Cert($publicKey);

        // Retornamos nuestro XML firmafo
        return $domDocument;
    }

}
