<?php
/**
 
 * Clase para enviar comprobante electrónicos a la SUNAT
 */

class ServicioSunat extends SoapClient
{

    public $XMLStr = "";

    public function setXMLStr($value)
    {
        $this->XMLStr = $value;
    }

    public function getXMLStr()
    {
        return $this->XMLStr;
    }

    public function __doRequest($request, $location, $action, $version, $one_way = 0)
    {
        $request = $this->XMLStr;

        $dom = new DOMDocument('1.0');

        try
        {
            $dom->loadXML($request);
        } catch (DOMException $e) {
            die($e->code);
        }

        $request = $dom->saveXML();

        //Solicitud
        return parent::__doRequest($request, $location, $action, $version, $one_way = 0);
    }

    public function SoapClientCall($SOAPXML)
    {
        return $this->setXMLStr($SOAPXML);
    }

}

/**
 * Clase Para enviar Documento
 */
class EnviarDocumento
{

    public static function soapCall($wsdlURL, $callFunction = "", $XMLString)
    {
        try {

            $client = new ServicioSunat($wsdlURL, array('trace' => true));
            $reply  = $client->SoapClientCall($XMLString);

            $respuesta = $client->__call("$callFunction", array(), array());

            return $client->__getLastResponse();

        } catch (SoapFault $fault) {
           /* if ($fault->faultstring != 'Could not connect to host') {
                //throw $fault;
				
            }*/
            
            $data=$fault->faultcode;
			$data=$data.$fault->faultstring.'<br>';
		//	$data=$data.$fault->faultactor.'<br>';
		//	$data=$data.$fault->detail.'<br>';
		//	$data=$data.$fault->_name.'<br>';
		//	$data=$data.$fault->headerfault;
			
			return $data;
			
        }
    }

    public static function writeFile($content, $nombreArchivo)
    {
        $rutaFinal = 'constancia_recepcion/CDR-' . $nombreArchivo;
        $cdr       = base64_decode($content);
        $archivo   = fopen($rutaFinal . '.zip', 'w+');
        fputs($archivo, $cdr);
        fclose($archivo);
        chmod($rutaFinal . '.zip', 0777);
        return true;
    }
}
